
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "pz.h"


static PzModule *module;
typedef struct _batt {
	int c;
	double p;
	time_t t;
} batt_level;
batt_level a, b;


double f;
int diff=0;
char rate[48];
char sec[8];
	
static void battery_draw(PzWidget *wid, ttk_surface srf)
{	
	#define BW wid->w - 25
	#define BH wid->h / 2 
	#define BP BW / 100
	
	a.c = pz_ipod_get_battery_level();
	a.p = a.c * 100/512;
	time(&a.t);
	
	f = a.p / 100;
	
	char s[48];
		
	
	
	snprintf(s, 48, "%g", a.p);
	strcat(s, "  percent charged");
	

	ttk_rect(srf, 10, 10, 10 + BW, BH, ttk_ap_getx("window.fg")->color);
	ttk_rect(srf, 10 + BW, 5 + BH/4, 15 + BW,  5 + BH - BH/4, ttk_ap_getx("window.fg")->color);
	ttk_fillrect(srf, 11, 11, 9 + BW, BH - 1, ttk_ap_getx("battery.bg")->color);
	ttk_fillrect(srf, 11, 11, 10 + f * BW, BH - 1, ttk_ap_getx("battery.fill.normal")->color);
	ttk_text(srf, ttk_textfont, 20, BH + 10, ttk_ap_getx("window.fg")->color, s);
	
}

static int battery_events(PzEvent *e)
{
	int ret = TTK_EV_CLICK;
	if (a.c > pz_ipod_get_battery_level())
	{
		b = a;
		e->wid->dirty = 1;
	}
	
	switch(e->type) {
	case PZ_EVENT_BUTTON_DOWN:
		switch(e->arg) {
		case PZ_BUTTON_MENU:
			pz_close_window(e->wid->win);
			break;
		
		default:
			ret = TTK_EV_UNUSED;
		}
		break;
	default:
		ret = TTK_EV_UNUSED;
		break;
	}
	return ret;
}

static PzWindow *new_battery()
{
	PzWindow *ret;
	
	ret = pz_new_window(_("Battery Moniter"), PZ_WINDOW_NORMAL);
	pz_add_widget(ret, battery_draw, battery_events);
	
	return pz_finish_window(ret);
}

static void init_battery()
{
	module = pz_register_module("batt", NULL);
	pz_menu_add_action("/Extras/Utilities/Battery Moniter", new_battery);
}

PZ_MOD_INIT(init_battery)
